define asm::volume::vnx(
  $type = 'nonthin',
  $size = '',
  $sp = 'a',
  $pool = '',
  $scope = '0',
  $folder = '',
  $ensure = 'present',
  $luns = '',
  $sgname = '',
  $host_name = '',
  $luns = {},
) {
  
  if !defined(Transport['vnx']) {
    transport{'vnx':
      name     => $settings::certname,
      provider => 'device_file',
      options  => {
        'scope'    => '0',
        'cli_path' => '/opt/Navisphere/bin/naviseccli',
      }
    }
  }

  if $sgname=='' {
    vnx_lun{$name:
      ensure        =>$ensure,
      lun_name      =>$name,
      type          =>$type,
      capacity      =>$size,
      default_owner =>$sp,
      pool_name     =>$pool,
      transport     =>Transport['vnx'],
    }
  }
  else{
    if $host_name==''{
      vnx_storagegroup{$name:
        ensure    =>$ensure,
        sg_name   =>$sgname,
        transport =>Transport['vnx'],
      }
    }
    else{
      vnx_storagegroup{$name:
        ensure    =>$ensure,
        sg_name   =>$sgname,
        luns      =>$luns,
        host_name =>$host_name,
        addonly   =>true,
        transport =>Transport['vnx'],
      }
    }
  }
}